double fnoise1=2147483648.0;
float f0=0.0;
float f2=2.0;
float f3=3.0;
float fPI=3.1415927;

float f_0_5=0.5;


float NoiseInt(int x, y, z)
{
/*
	int n = x + 57*y + 131*z;
	n = (n<<13) ^ n;
	return((n * (n * n +254351) + 326365363) & 0x7FFFFFFF)/2147483648.0;


*/

int n;
float result;

$mov	eax, y
$imul	eax, 57 
$mov	ecx, x 
$add	ecx, eax
$mov	edx, z
$imul	edx, 131
$add	ecx, edx
$mov	n, ecx
$mov    eax, n
$shl    eax, 0Dh
$xor    eax, n
$mov    n, eax
$mov    ecx, n
$imul   ecx, n
$add    ecx, 254351
$mov    edx, n
$imul   edx, ecx
$add    edx, 326365363
$and    edx, 7FFFFFFFh
$mov    n, edx
$fild   n
$fdiv   fnoise1
$fstp   result 

return result;

}
//----------------------------------------------------------------------------------------


// 
float InterpolateLin (float a, float b, float c)
{
//	return a * (1 - c) + b * c;
float result;

$fld1 
$fsub	c
$fmul   a
$fld    b
$fmul   c
$faddp  st(1), st(0)
$fstp   result;

return result;

}

//----------------------------------------------------------------------------------

float InterpolateCub (float a, float b, float c)
{
/*
	float c2 = c * c;
	c2 = c2 * 3 - c * c2 * 2;
	return a * (1 - c2) + b * c2;

*/

float c2;

$fld    c
$fmul   c
$fst    c2


$fmul   f3 
$fld    c
$fmul   c2
$fadd   st(0), st(0)  
$fsubp  st(1), st(0)
$fstp   c2
$fld1  
$fsub   c2
$fmul   a
$fld    b
$fmul   c2
$faddp  st(1), st(0)

$fstp c2

return c2;
}
//------------------------------------------------------------------------------------


float NoiseIntSmooth(int x, int y, int z)
{
/*
	return	(NoiseInt (x, y, z)*2 + NoiseInt (x, y+1, z) + NoiseInt (x+1, y, z) + NoiseInt (x, y, z+1) +
			NoiseInt (x, y-1, z) + NoiseInt (x-1, y, z) + NoiseInt (x, y, z-1))/8;
*/

float temp1, temp2, temp3, temp4, temp5, temp6, temp7, result;

temp1=NoiseInt (x, y, z);
$fld	temp1
//      2
$fadd	st(0), st(0)
$fstp	temp1

temp2=NoiseInt (x  , y+1, z);
temp3=NoiseInt (x+1, y  , z);
temp4=NoiseInt (x  , y  , z+1);

temp5=NoiseInt (x  , y-1, z);
temp6=NoiseInt (x-1, y  , z);
temp7=NoiseInt (x  , y  , z-1);

result=temp1+temp2+temp3+temp4+temp5+temp6+temp7 / 8.0;

return result;


}
//------------------------------------------------------------------------------------------


float InterpolateCos (float a, float b, float c)
{
/*
	float ft = cos (c * 3.1415927);
	ft = (1 + ft)/2;
	return a*ft +b*(1-ft);
*/
float ft;

$fld	c
$fmul   fPI
$fcos   
$fstp    ft
$fld1
$fadd   ft
$fdiv   f2
$fstp   ft
$fld    a
$fmul   ft
$fld1 
$fsub    ft
$fmul    b
$faddp   st(1), st(0)


$fstp ft

return ft;



}

//------------------------------------------------------------------------------------------------





float NoiseIter (float x, float y, float z, int InterpolationType)
{
int int_x, int_y, int_z;
float fract_x, fract_y, fract_z;
float v1, v2, v3, v4, v5, v6, v7, v8;
float u1, u2, u3, u4, w1, w2;
float result;

int_x=float2int(x);
int_y=float2int(y);
int_z=float2int(z);


//float fract_x = x - int_x;

$fild	int_x 
$fsubr	x 
$fstp   fract_x 

//float fract_y = y - int_y;
$fild	int_y 
$fsubr	y 
$fstp   fract_y 

//float fract_z = z - int_z;
$fild	int_z 
$fsubr	z 
$fstp   fract_z 


 v1 = NoiseInt (int_x,		int_y,		int_z		);
 v2 = NoiseInt (int_x + 1, int_y,		int_z		);
 v3 = NoiseInt (int_x,		int_y + 1,	int_z		);
 v4 = NoiseInt (int_x + 1, int_y + 1,	int_z		);
 v5 = NoiseInt (int_x,		int_y,		int_z + 1	);
 v6 = NoiseInt (int_x + 1, int_y,		int_z + 1	);
 v7 = NoiseInt (int_x,		int_y + 1,	int_z + 1	);
 v8 = NoiseInt (int_x + 1, int_y + 1,	int_z + 1	);

	switch (InterpolationType)
	{

	case 0:
		{

 u1 = InterpolateLin (v1, v2, fract_x);
 u2 = InterpolateLin (v3, v4, fract_x);
 u3 = InterpolateLin (v5, v6, fract_x);
 u4 = InterpolateLin (v7, v8, fract_x);

 w1 = InterpolateLin (u1, u2, fract_y);
 w2 = InterpolateLin (u3, u4, fract_y);
	
	result=InterpolateLin (w1, w2, fract_z);



			//---
			break;
		}


	case 1:
		{

 u1 = InterpolateCub (v1, v2, fract_x);
 u2 = InterpolateCub (v3, v4, fract_x);
 u3 = InterpolateCub (v5, v6, fract_x);
 u4 = InterpolateCub (v7, v8, fract_x);

 w1 = InterpolateCub (u1, u2, fract_y);
 w2 = InterpolateCub (u3, u4, fract_y);
	
	result=InterpolateCub (w1, w2, fract_z);


			//----
			break;
		}
	case 2:
		{

 u1 = InterpolateCos (v1, v2, fract_x);
 u2 = InterpolateCos (v3, v4, fract_x);
 u3 = InterpolateCos (v5, v6, fract_x);
 u4 = InterpolateCos (v7, v8, fract_x);

 w1 = InterpolateCos (u1, u2, fract_y);
 w2 = InterpolateCos (u3, u4, fract_y);
	
	result=InterpolateCos (w1, w2, fract_z);



			//---
			break;
		}



	} //switch



return result;

}

//--------------------------------------------------------------------------------------------




float Noise (float x, float y, float z, int NumberOfIterations, int InterpolationType)
{
	float result = 0.0;
	float amp = 1.0;
	float persist = 0.5;
	float freq = 1.0;
	int i;
	float temp1, temp2, temp3;

	for ( i = 0; i<=NumberOfIterations - 1; i++)
	{

/*		result += (NoiseIter (x * freq, y * freq, z / freq, InterpolationType) - 0.5) * 2 * amp;
		amp *= persist;
		freq *= 2;
*/

		temp1=x * freq;
		temp2=y * freq;
		temp3=z / freq;
                result=NoiseIter (temp1, temp2, temp3, InterpolationType);
                $fld  result
                $fsub f_0_5 
                $fadd st(0), st(0)
                $fmul amp
                $fadd result
                $fstp result

		amp *= persist;

		$fld  freq
                $fadd st(0), st(0)
                $fstp freq

	}

	result += 1.0;

//	result = (result < 0.0)? 0.0:result/2;
//	result = (result > 2.0)? 1.0:result/2;


$fld     result
$fcomp   f0
$fnstsw  ax
$test    ah, 1
$jz      short loc_40266E
result = f0;
$jmp     short loc_40267A
loc_40266E:                         
$fld       result  
$fdiv    f2
$fstp    result 
loc_40267A:



$fld     result  
$fcomp   f2 
$fnstsw  ax
$test    ah, 41h
$jnz     short loc_40269D
$fld1
$fstp    result 
$jmp     short loc_4026A9
loc_40269D:     
$fld     result  
$fdiv    f2
$fstp    result 
loc_4026A9:



return result;



}
//----------------------------------------------------------------------------------------------------------

