
// % 06.06.2005 ࠢ 訡  㭪樨 quat_Angles2Quaternion


//28.03.2005


//饭  w
// ୨ q ᫥ 室 ᮯ殮 conjugate ਮ q2  q
//  ६ q2*w*q
//⥬ q ॢ   饭 OpenGL



/*
================
Quaternion Camera
================
In order to rotate using quaternions, we need to convert some vectors
into quaternions, multiply some quats, then rip a vector from the 
resulting quaternion .. its not as hard as it sounds :)
1) convert the View vector into a quaternion called quatView
(Vxyzw=Viewxyz0)
2) convert the Angle/Axis into a quaternion called quatRot
quatRot.x = Axis.x * sin(theta/2)
quatRot.y = Axis.y * sin(theta/2)
quatRot.z = Axis.z * sin(theta/2)
quatRot.w = cos(theta/2)
3) create a conjugate quaternion from quatRot called quatTemp2
quatTemp2.x=-quatRot.x
quatTemp2.y=-quatRot.y
quatTemp2.z=-quatRot.z
4) multiply W=((quatRot * quatView) * quatTemp2)
5) new view vector is in W.xyz
*/

#define PIq 3.14159265358979323846 
#define EPSILON  0.000001f

:float f0_0=0.0f;
:float f2_0=2.0f;
:float f0_25=0.25f;
:float fp_SlerpTolerance=0.000001f;
:float fp_One=1.0f;
//float fp_Half=0.5f;

//ࠡ  ୨

struct CQUATERNION {
float x;
float y;
float z;
float w;
};





//   ୨
//ESI 㪠⥫   
//ECX 㪠⥫  ୨ 

:fastcall quat_CreateView(ESI, ECX)
{
$fld  DSFLOAT[esi]
$fstp DSFLOAT[ecx]
$fld  DSFLOAT[esi+4]
$fstp DSFLOAT[ecx+4]
$fld  DSFLOAT[esi+4+4]
$fstp DSFLOAT[ecx+4+4]
$fld  f0_0
$fstp DSFLOAT[ecx+4+4+4]
}



//#ECX - 㪠⥫  ୨
//identity quaternion has x, y, z as 0 and w as 1.
:fastcall quat_identity(ECX)
{
$mov DSDWORD[ecx+#CQUATERNION.x],0
$mov DSDWORD[ecx+#CQUATERNION.y],0
$mov DSDWORD[ecx+#CQUATERNION.z],0
$fld1
$fstp DSFLOAT[ecx+#CQUATERNION.w]
}

/*
  qt_zero: zero quaternion (out = [0,0,0,0]).
*/
:fastcall quat_zero(ECX)
{

$mov DSDWORD[ecx+#CQUATERNION.x],0
$mov DSDWORD[ecx+#CQUATERNION.y],0
$mov DSDWORD[ecx+#CQUATERNION.z],0
$mov DSDWORD[ecx+#CQUATERNION.w],0


}


//fastcall quat_copy (c_QUAT *a, c_QUAT *out)
/*
  qt_copy: quaternion copy (out = a).
*/
:fastcall quat_copy (EBX, ECX)
{

DSFLOAT[ECX+#CQUATERNION.x]=DSFLOAT[EBX+#CQUATERNION.x];
DSFLOAT[ECX+#CQUATERNION.y]=DSFLOAT[EBX+#CQUATERNION.y];
DSFLOAT[ECX+#CQUATERNION.z]=DSFLOAT[EBX+#CQUATERNION.z];
DSFLOAT[ECX+#CQUATERNION.w]=DSFLOAT[EBX+#CQUATERNION.w];

}


/*
  qt_add: quaternion addition (out = a+b).
*/
//void qt_add (c_QUAT *a, c_QUAT *b, c_QUAT *out)
:fastcall quat_add(EAX, EBX, ECX)
{

CQUATERNION temp;

  temp.x = DSFLOAT[EAX+#CQUATERNION.x]+DSFLOAT[EBX+#CQUATERNION.x]; 
  temp.y = DSFLOAT[EAX+#CQUATERNION.y]+DSFLOAT[EBX+#CQUATERNION.y]; 
  temp.z = DSFLOAT[EAX+#CQUATERNION.z]+DSFLOAT[EBX+#CQUATERNION.z]; 
  temp.w = DSFLOAT[EAX+#CQUATERNION.w]+DSFLOAT[EBX+#CQUATERNION.w]; 

  quat_copy (#temp, ECX);

}

//---
:fastcall quat_sub(EAX, EBX, ECX)
{

CQUATERNION temp;

  temp.x = DSFLOAT[EAX+#CQUATERNION.x]-DSFLOAT[EBX+#CQUATERNION.x]; 
  temp.y = DSFLOAT[EAX+#CQUATERNION.y]-DSFLOAT[EBX+#CQUATERNION.y]; 
  temp.z = DSFLOAT[EAX+#CQUATERNION.z]-DSFLOAT[EBX+#CQUATERNION.z]; 
  temp.w = DSFLOAT[EAX+#CQUATERNION.w]-DSFLOAT[EBX+#CQUATERNION.w]; 

  quat_copy (#temp, ECX);

}



/*
  qt_length: computes quaternion magnitude.
*/
:float fastcall quat_length (ECX)
{
//  return (float)sqrt (a->w*a->w + a->x*a->x + a->y*a->y + a->z*a->z);

$FLD  DSFLOAT[ECX+#CQUATERNION.x]
$FMUL DSFLOAT[ECX+#CQUATERNION.x]

$FLD  DSFLOAT[ECX+#CQUATERNION.y]
$FMUL DSFLOAT[ECX+#CQUATERNION.y]

$FADD


$FLD  DSFLOAT[ECX+#CQUATERNION.z]
$FMUL DSFLOAT[ECX+#CQUATERNION.z]

$FADD

$FLD  DSFLOAT[ECX+#CQUATERNION.w]
$FMUL DSFLOAT[ECX+#CQUATERNION.w]

$FADD

$FSQRT

return st(0);
}


/*
  qt_dot: computes dot product of a*b.
*/
:float fastcall quat_dot (EBX, ECX)
{
  float len;
//  len = 1.0f / (qt_length (a) * qt_length (b));
  len=quat_length(EBX); 
  len*=quat_length(ECX); 
  len=1.0f / len;

//  return (a->w*b->w + a->x*b->x + a->y*b->y + a->z*b->z) * len;

$FLD  DSFLOAT[ECX+#CQUATERNION.x]
$FMUL DSFLOAT[ECX+#CQUATERNION.x]
$FLD  DSFLOAT[ECX+#CQUATERNION.y]
$FMUL DSFLOAT[ECX+#CQUATERNION.y]
$FADD

$FLD  DSFLOAT[ECX+#CQUATERNION.z]
$FMUL DSFLOAT[ECX+#CQUATERNION.z]
$FADD

$FLD  DSFLOAT[ECX+#CQUATERNION.w]
$FMUL DSFLOAT[ECX+#CQUATERNION.w]
$FADD

$FMUL len

return st(0);

}


:float fastcall quat_dotunit (EBX, ECX)
{
/*
  qt_dotunit: computes dot product of a*b.
*/
//  return (a->w*b->w + a->x*b->x + a->y*b->y + a->z*b->z);

$FLD  DSFLOAT[ECX+#CQUATERNION.x]
$FMUL DSFLOAT[ECX+#CQUATERNION.x]
$FLD  DSFLOAT[ECX+#CQUATERNION.y]
$FMUL DSFLOAT[ECX+#CQUATERNION.y]
$FADD

$FLD  DSFLOAT[ECX+#CQUATERNION.z]
$FMUL DSFLOAT[ECX+#CQUATERNION.z]
$FADD

$FLD  DSFLOAT[ECX+#CQUATERNION.w]
$FMUL DSFLOAT[ECX+#CQUATERNION.w]
$FADD



return st(0);

}


/*
  qt_scale: scale quaternion.
*/
//EBX - Lp quanterion 
//ECX - Lp float scale
//ESI - Lp out quanterion
:fastcall quat_scale (EBX, ECX, ESI)
{
CQUATERNION temp;


  temp.x = DSFLOAT[EBX+#CQUATERNION.x] * DSFLOAT[ECX];
  temp.y = DSFLOAT[EBX+#CQUATERNION.y] * DSFLOAT[ECX];
  temp.z = DSFLOAT[EBX+#CQUATERNION.z] * DSFLOAT[ECX];
  temp.w = DSFLOAT[EBX+#CQUATERNION.w] * DSFLOAT[ECX];

  quat_copy (#temp, ESI);

}


/*
  qt_rescale: scale quaternion to a new length.
*/
//void qt_rescale (c_QUAT *a, float s, c_QUAT *out)
//EBX - Lp quanterion 
//ECX - Lp float scale
//ESI - Lp out quanterion
:fastcall quat_rescale(EBX, ECX, ESI)
{
float  len;
DWORD ECX_, EBX_;
ECX_=ECX;
EBX_=EBX;

  len = quat_length (EBX);

  if (len==0.0) { zaplatka1();
                 quat_identity(ESI);
                 return;
                }
  zaplatka1();


//  s /= len;

  ECX=ECX_;
  DSFLOAT[ECX]=DSFLOAT[ECX] / len;
  EBX=EBX_;
  quat_scale (EBX, ECX, ESI);



}




//ᮧ ᮯ殮 ୨  㣮 ୨ 
//#EAX - 㪠⥫  ୨ 
//#EBX - 㪠⥫ 㤠  ᮯ殮 ୨
:fastcall quat_conjugate(EAX, EBX)
{
$fld DSFLOAT[EAX+#CQUATERNION.x]
$fchs
$fstp DSFLOAT[EBX+#CQUATERNION.x]

$fld DSFLOAT[EAX+#CQUATERNION.y]
$fchs
$fstp DSFLOAT[EBX+#CQUATERNION.y]

$fld DSFLOAT[EAX+#CQUATERNION.z]
$fchs
$fstp DSFLOAT[EBX+#CQUATERNION.z]

$fld DSFLOAT[EAX+#CQUATERNION.w]
$fchs
$fstp DSFLOAT[EBX+#CQUATERNION.w]

}



// ୨  ᭮ 㣫   
//#EAX - 㪠⥫   x.y.z
//#EBX - 㪠⥫  稭 ࠤᮢ
//#EDI - 㪠⥫  室 ୨
:fastcall quat_CreateFromAxisAngle(EAX, EBX , EDI)
{
float angle, thetasin, thetacos;

angle =  DSFLOAT[EBX] / 180.0f * PIq;  //ॢ  ࠤ

thetasin = sin( angle / 2.0f );
thetacos = cos( angle / 2.0f );



$FLD  DSFLOAT[EAX]
$FMUL thetasin
$FSTP DSFLOAT[EDI+#CQUATERNION.x]

$FLD  DSFLOAT[EAX+4]
$FMUL thetasin
$FSTP DSFLOAT[EDI+#CQUATERNION.y]

$FLD  DSFLOAT[EAX+8]
$FMUL thetasin
$FSTP DSFLOAT[EDI+#CQUATERNION.z]

$FLD  thetacos
$FSTP DSFLOAT[EDI+#CQUATERNION.w]






} 




// 㣮    ୨ 
//#EAX - 㪠⥫   x.y.z
//#EBX - 㪠⥫  稭 ࠤᮢ
//#EDI - 㪠⥫  ୨


:fastcall quat_CreateToAxisAngle(EAX, EBX , EDI)
{


}


// ୨
//#esi 㪠⥫  ୨ 1
//#edi 㪠⥫  ୨ 2
//#ecx 㪠⥫  室 ୨ 1*2=3
:fastcall quat_Multiply(ESI, EDI, ECX)
{

//C.x = | A.w*B.x + A.x*B.w + A.y*B.z - A.z*B.y |

$fld   DSFLOAT[esi+#CQUATERNION.w]
$fmul  DSFLOAT[edi+#CQUATERNION.x]
$fld   DSFLOAT[esi+#CQUATERNION.x]
$fmul  DSFLOAT[edi+#CQUATERNION.w]
$fadd
$fld   DSFLOAT[esi+#CQUATERNION.y]
$fmul  DSFLOAT[edi+#CQUATERNION.z]
$fadd
$fld   DSFLOAT[esi+#CQUATERNION.z]
$fmul  DSFLOAT[edi+#CQUATERNION.y]
$fsub
$fstp  DSFLOAT[ecx+#CQUATERNION.x]

//C.y = | A.w*B.y - A.x*B.z + A.y*B.w + A.z*B.x |

$fld   DSFLOAT[esi+#CQUATERNION.w]
$fmul  DSFLOAT[edi+#CQUATERNION.y]
$fld   DSFLOAT[esi+#CQUATERNION.x]
$fmul  DSFLOAT[edi+#CQUATERNION.z]
$fsub
$fld   DSFLOAT[esi+#CQUATERNION.y]
$fmul  DSFLOAT[edi+#CQUATERNION.w]
$fadd
$fld   DSFLOAT[esi+#CQUATERNION.z]
$fmul  DSFLOAT[edi+#CQUATERNION.x]
$fadd
$fstp  DSFLOAT[ecx+#CQUATERNION.y]


//C.z = | A.w*B.z + A.x*B.y - A.y*B.x + A.z*B.w |

$fld   DSFLOAT[esi+#CQUATERNION.w]
$fmul  DSFLOAT[edi+#CQUATERNION.z]
$fld   DSFLOAT[esi+#CQUATERNION.x]
$fmul  DSFLOAT[edi+#CQUATERNION.y]
$fadd
$fld   DSFLOAT[esi+#CQUATERNION.y]
$fmul  DSFLOAT[edi+#CQUATERNION.x]
$fsub
$fld   DSFLOAT[esi+#CQUATERNION.z]
$fmul  DSFLOAT[edi+#CQUATERNION.w]
$fadd
$fstp  DSFLOAT[ecx+#CQUATERNION.z]


//C.w = | A.w*B.w - A.x*B.x - A.y*B.y - A.z*B.z |

$fld   DSFLOAT[esi+#CQUATERNION.w]
$fmul  DSFLOAT[edi+#CQUATERNION.w]
$fld   DSFLOAT[esi+#CQUATERNION.x]
$fmul  DSFLOAT[edi+#CQUATERNION.x]
$fsub
$fld   DSFLOAT[esi+#CQUATERNION.y]
$fmul  DSFLOAT[edi+#CQUATERNION.y]
$fsub
$fld   DSFLOAT[esi+#CQUATERNION.z]
$fmul  DSFLOAT[edi+#CQUATERNION.z]
$fsub
$fstp  DSFLOAT[ecx+#CQUATERNION.w]


}

//ଠ ୨
//which gives us a quaternion of length 1 (which is very important for rotations). 
:fastcall quat_Normalize(ECX)
{
float fQ;

//First calculate Q length of Quat, where Q=sqrt(w^2+x^2+y^2+z^)

$fld  DSFLOAT[ecx+#CQUATERNION.w]
$fmul DSFLOAT[ecx+#CQUATERNION.w]
$fld  DSFLOAT[ecx+#CQUATERNION.x]
$fmul DSFLOAT[ecx+#CQUATERNION.x]
$fadd
$fld  DSFLOAT[ecx+#CQUATERNION.y]
$fmul DSFLOAT[ecx+#CQUATERNION.y]
$fadd
$fld  DSFLOAT[ecx+#CQUATERNION.z]
$fmul DSFLOAT[ecx+#CQUATERNION.z]
$fadd
$fsqrt
$fstp fQ

//Normalize Quat by dividing its components by Q
$fld  DSFLOAT[ecx+#CQUATERNION.w]
$fdiv fQ
$fstp DSFLOAT[ecx+#CQUATERNION.w]

$fld  DSFLOAT[ecx+#CQUATERNION.x]
$fdiv fQ
$fstp DSFLOAT[ecx+#CQUATERNION.x]

$fld  DSFLOAT[ecx+#CQUATERNION.y]
$fdiv fQ
$fstp DSFLOAT[ecx+#CQUATERNION.y]

$fld  DSFLOAT[ecx+#CQUATERNION.z]
$fdiv fQ
$fstp DSFLOAT[ecx+#CQUATERNION.z]

}




// ୨   饭 OpenGL
//ECX 㪠⥫  ୨ 
//ESI 㪠⥫    4x4

:fastcall quat_CreateMatrix(ECX, ESI)
	{

    // ਮ 砥  饭

    //             2     2								
    //      1 - (2y  + 2z )     2xy + 2zw         2xz - 2yw			0	
    //     										
    //                               2     2						
    // M =  2xy - 2zw         1 - (2x  + 2z )      2zy + 2xw			0	
    //     										
    //                                                 2     2			 
    //      2xz + 2yw         2yz - 2xw         1 - (2x  + 2y )	0	        0  
    //     										
    //     										
    //      0			   0			 0			1	 													 
    //     										
    //
 
// Fill in the rows of the 4x4 matrix, according to the quaternion to matrix equations
// First row
//pMatrix[ 0] = 1.0f - 2.0f * ( y * y + z * z );  


$FLD1                                

$FLD   DSFLOAT[ECX+#CQUATERNION.y]    
$FMUL  DSFLOAT[ECX+#CQUATERNION.y]

$FLD   DSFLOAT[ECX+#CQUATERNION.z]
$FMUL  DSFLOAT[ECX+#CQUATERNION.z]

$FADD
$FMUL  f2_0

$FSUB                                  
$FSTP DSFLOAT[0*4+ESI]


//pMatrix[ 1] = 2.0f * ( x * y - w * z );  
$FLD  DSFLOAT[ECX+#CQUATERNION.x]
$FMUL DSFLOAT[ECX+#CQUATERNION.y]

$FLD  DSFLOAT[ECX+#CQUATERNION.w]
$FMUL DSFLOAT[ECX+#CQUATERNION.z]

$FSUB

$FMUL f2_0

$FSTP DSFLOAT[1*4+ESI]

//pMatrix[ 2] = 2.0f * ( x * z + w * y );  
$FLD  DSFLOAT[ECX+#CQUATERNION.x]
$FMUL DSFLOAT[ECX+#CQUATERNION.z]

$FLD  DSFLOAT[ECX+#CQUATERNION.w]
$FMUL DSFLOAT[ECX+#CQUATERNION.y]

$FADD
$FMUL f2_0

$FSTP DSFLOAT[2*4+ESI]

//pMatrix[ 3] = 0.0f;  
$MOV  DSDWORD[3*4+ESI],0
//----------------------------------

//Second row
//pMatrix[ 4] = 2.0f * ( x * y + w * z );  
$FLD  DSFLOAT[ECX+#CQUATERNION.x]
$FMUL DSFLOAT[ECX+#CQUATERNION.y]

$FLD  DSFLOAT[ECX+#CQUATERNION.w]
$FMUL DSFLOAT[ECX+#CQUATERNION.z]

$FADD
$FMUL f2_0

$FSTP DSFLOAT[4*4+ESI]

//pMatrix[ 5] = 1.0f - 2.0f * ( x * x + z * z );  
$FLD1                                

$FLD   DSFLOAT[ECX+#CQUATERNION.x]    
$FMUL  DSFLOAT[ECX+#CQUATERNION.x]

$FLD   DSFLOAT[ECX+#CQUATERNION.z]
$FMUL  DSFLOAT[ECX+#CQUATERNION.z]

$FADD
$FMUL  f2_0

$FSUB                                  
$FSTP DSFLOAT[5*4+ESI]

//pMatrix[ 6] = 2.0f * ( y * z - w * x );  
$FLD  DSFLOAT[ECX+#CQUATERNION.y]
$FMUL DSFLOAT[ECX+#CQUATERNION.z]

$FLD  DSFLOAT[ECX+#CQUATERNION.w]
$FMUL DSFLOAT[ECX+#CQUATERNION.x]

$FSUB
$FMUL f2_0

$FSTP DSFLOAT[6*4+ESI]

//pMatrix[ 7] = 0.0f;
$MOV  DSDWORD[7*4+ESI],0


//Third row
//pMatrix[ 8] = 2.0f * ( x * z - w * y );  
$FLD  DSFLOAT[ECX+#CQUATERNION.x]
$FMUL DSFLOAT[ECX+#CQUATERNION.z]

$FLD  DSFLOAT[ECX+#CQUATERNION.w]
$FMUL DSFLOAT[ECX+#CQUATERNION.y]

$FSUB
$FMUL f2_0

$FSTP DSFLOAT[8*4+ESI]


//pMatrix[ 9] = 2.0f * ( y * z + w * x );  
$FLD   DSFLOAT[ECX+#CQUATERNION.y]    
$FMUL  DSFLOAT[ECX+#CQUATERNION.z]

$FLD   DSFLOAT[ECX+#CQUATERNION.w]
$FMUL  DSFLOAT[ECX+#CQUATERNION.x]

$FADD
$FMUL  f2_0

$FSTP DSFLOAT[9*4+ESI]

//pMatrix[10] = 1.0f - 2.0f * ( x * x + y * y );  
$FLD1                                

$FLD   DSFLOAT[ECX+#CQUATERNION.x]    
$FMUL  DSFLOAT[ECX+#CQUATERNION.x]

$FLD   DSFLOAT[ECX+#CQUATERNION.y]
$FMUL  DSFLOAT[ECX+#CQUATERNION.y]

$FADD
$FMUL  f2_0

$FSUB                                  
$FSTP DSFLOAT[10*4+ESI]

//pMatrix[11] = 0.0f;  
$MOV  DSDWORD[11*4+ESI],0


// Fourth row
//pMatrix[12] = 0;  
$MOV  DSDWORD[12*4+ESI],0

//pMatrix[13] = 0;  
$MOV  DSDWORD[13*4+ESI],0

//pMatrix[14] = 0;  
$MOV  DSDWORD[14*4+ESI],0

//pMatrix[15] = 1.0f;
$FLD1
$FSTP DSFLOAT[15*4+ESI]



};



//--------------------------------------------------------------------------------------------------------------
//୨

//* Here comes famous Spherical Linear intERPolation (AKA SLERP)
//* slerp(q1,q2,t)=sin((1-t)*a)/sin(a)*q1+sin(t*a)/sin(a)*q2
//* a is the angle between q1 and q2
// IN: ESI=q1 ptr (from)
//     EDI=q2 ptr (to)
//     ST=t (so called blend factor [0..1])
//    EBX=ptr to quaternion to store result in

struct QUATER2{
float w;
float x;
float y;
float z;
};

:QUATER2 q1_, q2_, q3_;
:DWORD  LpEBX;


:fastcall quat_Slerp(ESI, EDI, st(0), EBX)
{

//LpEBX=EBX;
//EBX=#q3_;
/*
q1_.w=DSFLOAT[ESI+#CQUATERNION.w];
q1_.x=DSFLOAT[ESI+#CQUATERNION.x];
q1_.y=DSFLOAT[ESI+#CQUATERNION.y];
q1_.z=DSFLOAT[ESI+#CQUATERNION.z];

q2_.w=DSFLOAT[EDI+#CQUATERNION.w];
q2_.x=DSFLOAT[EDI+#CQUATERNION.x];
q2_.y=DSFLOAT[EDI+#CQUATERNION.y];
q2_.z=DSFLOAT[EDI+#CQUATERNION.z];

ESI=#q1_;
EDI=#q2_;
*/

asm {
 push ebx
 fldz
 sub ebx,ebx  // used to index float members of quaternions
_CalcDotProd:
 fld DSFLOAT [esi+ebx]
 fmul DSFLOAT [edi+ebx]
 faddp st(1)
 add bl,4   //SIZE Float
 cmp bl,16  //SIZE Quaternion
jb _CalcDotProd

//* Now make sure we're traveling along the shortest arc on the
//* quaternion sphere. This can be checked using the following
//* relation:
//* (q1+q2)dot(q1+q2)<(q1-q2)dot(q1-q2),
//* if this is true we're need to negate destination quaternion q2
//* and use linear interpolation instead of spherical.
//* Is there an easier way to do this?
 fldz
 sub ebx,ebx
 fld st(0)             // d1=0,d2=0 - accumulators for dot products
_CalcDots:
 fld DSFLOAT [esi+ebx]
 fld DSFLOAT [edi+ebx]
 fld st(0)                 // q2,q2,q1,d1,d2
 fadd st(0),st(2)          // q1+q2,q2,q1,d1,d2
 fxch st(1)                  // q2,q1+q2,q1,d1,d2
 fsubp st(2)             // q1+q2,q1-q2,d1,d2
 fmul st(0),st(0)
 fxch
 fmul st(0),st(0)
 fxch
 faddp st(2)        // q1-q2,d1,d2
 faddp st(2)        // d1,d2
 add bl,4 //SIZE Float
 cmp bl,16 //SIZE Quaternion
jb _CalcDots
 fcompp
// GetFPUFlags
 fnstsw ax
 sahf

 pop ebx
jb short _DoShort
// Now we have dot product q1*q2=cos(a) => a=arccos(q1*q2)
// arccos(x)=arctan(sqrt(1-x^2)/x)
 fld st(0)                   // x=dot=cos
 fmul st,st(0)               // x^2, x, t
 fsubr fp_One    // 1-x^2, x, t
 fcom  fp_SlerpTolerance
// GetFPUFlags
 fnstsw ax
 sahf

jae short _Slerp
// 1-cos(a)*cos(a)<0.000001 => abs[cos(a)]>0.99(9) => a is very close to 0
//* Angle is too small -> q1 and q2 are very close to each other ->
//* -> we can (we must) use a normal linear interpolation
 fcompp                      // remove x^2 and x
 fld st(0)
 fsubr fp_One    // 1-t, t
jmp short _Calc
//* Angle is large enough and we're moving at the shortest path,
//* -> we can (we must) use a normal linear interpolation
 fcompp                       // remove x^2 and x
 fld st(0)
 fsubr fp_One     // 1-t, t
jmp short _Calc
//* Angle is large enough and we're moving at the shortest path,
//* so interpolate spherically.
_Slerp:
// arccos(x)=arctan(sqrt(1-x^2)/x)
 fsqrt
 fld st(0)                    // sqrt(1-x^2), sqrt(1-x^2), x, t
 // cos(a)=dot=x// cos^2(a)+sin^2(a)=1 => sin(a)=sqrt(1-cos^2(a))=sqrt(1-x^2)
 fdivr fp_One     // 1/sin(a)
 fxch st(2)                   // x, sqrt(1-x*x), 1/sin(a), t
 fpatan                       // a=arctan (st(1)/st), 1/sin(a), t
 fld st(0)                    // a, a, 1/sin(a), t
 fmul st(0),st(3)                // t*a, a, 1/sin(a), t
 fsin                         // sin(t*a), a, 1/sin(a), t
 fmul st(0),st(2)                // sin(t*a)/sin(a), a, 1/sin(a), t
 fxch st(3)                   // t, a, 1/sin(a), sin(t*a)/sin(a)
 fsubr fp_One                 // 1-t, a, 1/sin(a), sin(t*a)/sin(a)
 fmulp st(1)                  // (1-t)*a, 1/sin(a), sin(t*a)/sin(a)
 fsin                         // sin((1-t)*a), 1/sin(a), sin(t*a)/sin(a)
 fmulp st(1)                  // sin((1-t)*a)/sin(a), sin(t*a)/sin(a)
_Calc:
 push esi
 push edi
 push ebx
 xchg edi,ebx
 mov ecx,4
 sub ebx,esi
_qMulAdd:
 fld DSFLOAT [esi]          // q1.n, (1-t), t
 fmul st(0),st(1)                // (1-t)*q1.n, (1-t), t
 fld DSFLOAT [esi+ebx]      // q2.n, (1-t)*q1.n, (1-t), t
 fmul st(0),st(3)                // t*q2.n, (1-t)*q1.n, (1-t), t
 faddp st(1)                // (1-t)*q1.n+t*q2.n, (1-t), t
 add esi,4 //SIZE Float
 fstp DSFLOAT [edi]
 add edi,4 //SIZE Float
loop _qMulAdd
_Done:
 pop ebx
 pop edi
 pop esi
 fcompp                       // remove scale factors
 ret
_DoShort:
 fstp st(0)                   // remove dot
 fld st(0)
 fsubr fp_One     // 1-t,t


// IF 0// experimental, removed for now
/*
  fldpi
  fmul fp_Half
  fmul st(2),st(0)               // (1-t)*(PI/2),t
  fmulp st(1)                  // (1-t)*(PI/2),t*(PI/2)
  fxch
  fsin
  fxch
  fsin                        // sin[(1-t)*(pi/2)],sin[t*(pi/2)]
*/
// ENDIF


 push esi
 push edi
 push ebx
 xchg edi,ebx
 mov ecx,4
 sub ebx,esi
 // to=-q2
_calcshort:
 fld DSFLOAT [esi]          // q1.n, (1-t), t
 fmul st(0),st(1)                // (1-t)*q1.n, (1-t), t
 fld DSFLOAT [esi+ebx]      // q2.n, (1-t)*q1.n, (1-t), t
 fmul st(0),st(3)                // t*q2.n, (1-t)*q1.n, (1-t), t
 fsubp st(1)              // (1-t)*q1.n-t*q2.n, (1-t), t
 add esi,4 //SIZE Float
 fstp DSFLOAT [edi]
 add edi,4 //SIZE Float
 loop _calcshort
 jmp _Done



    }

/*
EBX=LpEBX;
DSFLOAT[EBX+#CQUATERNION.x]=q3_.x;
DSFLOAT[EBX+#CQUATERNION.y]=q3_.y;
DSFLOAT[EBX+#CQUATERNION.z]=q3_.z;
DSFLOAT[EBX+#CQUATERNION.w]=q3_.w;
*/


}



// ୨  ᭮  
//EDI - 㪠⠥   饭
//EAX - ᮤন ⢮  
//ECX - 㪠⥫  ୨

//This creates a quaternion from a 3x3 or a 4x4 matrix, depending on rowColumnCount
//void quat_CreateFromMatrix(DWORD pTheMatrix, rowColumnCount, LpQuat)
:fastcall quat_CreateFromMatrix(EDI, EAX, ECX)
{
float fdiagonal;
float fTheScale;
DWORD pMatrix;
float m4x4[16]; //Create a 4x4 matrix to convert a 3x3 matrix to a 4x4 matrix (If rowColumnCount == 3)

//ECX=LpQuat;

// Make sure the matrix has valid memory and it's not expected that we allocate it.
// Also, we do a check to make sure the matrix is a 3x3 or a 4x4 (must be 3 or 4).

//    if (!pTheMatrix) return;
//    if (rowColumnCount != 3) && (rowColumnCount != 4) return;
    if (!EDI) return;
    if (EAX != 3) && (EAX != 4) return;

// This function is used to take in a 3x3 or 4x4 matrix and convert the matrix
// to a quaternion.  If rowColumnCount is a 3, then we need to convert the 3x3
// matrix passed in to a 4x4 matrix, otherwise we just leave the matrix how it is.
// Since we want to apply a matrix to an OpenGL matrix, we need it to be 4x4.

// Point the matrix pointer to the matrix passed in, assuming it's a 4x4 matrix
//    pMatrix=pTheMatrix;
 pMatrix=EDI;

// If the matrix is a 3x3 matrix (which it is for Quake3), then convert it to a 4x4
//    if (rowColumnCount == 3) {
    IF (EAX == 3) {

        // Set the 9 top left indices of the 4x4 matrix to the 9 indices in the 3x3 matrix.
        // It would be a good idea to actually draw this out so you can visualize it.
        //m4x4[0]  = pTheMatrix[0];	m4x4[1]  = pTheMatrix[1];	m4x4[2]  = pTheMatrix[2];
//        ESI=pTheMatrix;
//        EDI=#m4x4;

        ESI=pMatrix;
        EDI=#m4x4;

        DSFLOAT[0*4+EDI]=DSFLOAT[0*4+ESI];
        DSFLOAT[1*4+EDI]=DSFLOAT[1*4+ESI];
        DSFLOAT[2*4+EDI]=DSFLOAT[2*4+ESI];
        DSFLOAT[3*4+EDI]=0.0f;



        //m4x4[4]  = pTheMatrix[3];	m4x4[5]  = pTheMatrix[4];	m4x4[6]  = pTheMatrix[5];
        DSFLOAT[4*4+EDI]=DSFLOAT[3*4+ESI];
        DSFLOAT[5*4+EDI]=DSFLOAT[4*4+ESI];
        DSFLOAT[6*4+EDI]=DSFLOAT[5*4+ESI];
        DSFLOAT[7*4+EDI]=0.0f;



        //m4x4[8]  = pTheMatrix[6];	m4x4[9]  = pTheMatrix[7];	m4x4[10] = pTheMatrix[8];
        DSFLOAT[8*4+EDI] =DSFLOAT[6*4+ESI];
        DSFLOAT[9*4+EDI] =DSFLOAT[7*4+ESI];
        DSFLOAT[10*4+EDI]=DSFLOAT[8*4+ESI];
        DSFLOAT[11*4+EDI]=0.0f;


// Since the bottom and far right indices are zero, set the bottom right corner to 1.
// This is so that it follows the standard diagonal line of 1's in the identity matrix.
        //m4x4[15] = 1;
        DSFLOAT[12*4+EDI]=0.0f;
        DSFLOAT[13*4+EDI]=0.0f;
        DSFLOAT[14*4+EDI]=0.0f;
        DSFLOAT[15*4+EDI]=1.0f;

        // Set the matrix pointer to the first index in the newly converted matrix
//        pMatrix=EDI;

                           }



// The next step, once we made sure we are dealing with a 4x4 matrix, is to check the
// diagonal of the matrix.  This means that we add up all of the indices that comprise
// the standard 1's in the identity matrix.  If you draw out the identity matrix of a
// 4x4 matrix, you will see that they 1's form a diagonal line.  Notice we just assume
// that the last index (15) is 1 because it is not effected in the 3x3 rotation matrix.

// Find the diagonal of the matrix by adding up it's diagonal indices.
// This is also known as the "trace", but I will call the variable diagonal.
//float diagonal = pMatrix[0] + pMatrix[5] + pMatrix[10] + 1;
    $fld1
    $fadd DSFLOAT[edi]
    $fadd DSFLOAT[5*4+edi]
    $fadd DSFLOAT[10*4+edi]
    $fstp fdiagonal      
//float scale = 0.0f;
    fTheScale=0.0f;



// Below we check if the diagonal is greater than zero.  To avoid accidents with
// floating point numbers, we substitute 0 with 0.00000001.  If the diagonal is
// great than zero, we can perform an "instant" calculation, otherwise we will need
// to identify which diagonal element has the greatest value.  Note, that it appears
// that %99 of the time, the diagonal IS greater than 0 so the rest is rarely used.

// If the diagonal is greater than zero 
      $mov eax, SSDWORD[#fdiagonal];
      IF (EAX>0)
      {
      $and eax,80000000h

      IF (EAX== 0) 
      {  //if its not 0 and its not negative :)
         // Calculate the scale of the diagonal
         //fTheScale = float(sqrt(diagonal ) * 2);
        $fld fdiagonal
        $fsqrt
        $fmul f2_0
        $fstp fTheScale         
        
         //Calculate the x, y, x and w of the quaternion through the respective equation
         // x = ( pMatrix[9] - pMatrix[6] ) / scale;
        $fld  DSFLOAT[9*4+EDI]
        $fsub DSFLOAT[6*4+EDI]
        $fdiv fTheScale
        $fstp DSFLOAT[ECX+#CQUATERNION.x]
7
        //y = ( pMatrix[2] - pMatrix[8] ) / scale;
        $fld  DSFLOAT[2*4+EDI]
        $fsub DSFLOAT[8*4+EDI]
        $fdiv fTheScale
        $fstp DSFLOAT[ECX+#CQUATERNION.y]

        //z = ( pMatrix[4] - pMatrix[1] ) / scale;
        $fld  DSFLOAT[4*4+EDI]
        $fsub DSFLOAT[1*4+EDI]
        $fdiv fTheScale
        $fstp DSFLOAT[ECX+#CQUATERNION.z]

        //w = 0.25f * scale;
        $fld  f0_25
        $fmul fTheScale
        $fstp DSFLOAT[ECX+#CQUATERNION.w]
        $jmp PastThisShit
      }
      }

        // If the first element of the diagonal is the greatest value
        //if ( pMatrix[0] > pMatrix[5] && pMatrix[0] > pMatrix[10] )  
        IF (DSFLOAT[EDI] > DSFLOAT[5*4+EDI])  &&  (DSFLOAT[EDI] > DSFLOAT[10*4+EDI])
        {

// Find the scale according to the first element, and double that value
//scale  = (float)sqrt( 1.0f + pMatrix[0] - pMatrix[5] - pMatrix[10] ) * 2.0f;
        $fld1
        $fadd DSFLOAT[edi]
        $fsub  DSFLOAT[5*4+edi]
        $fsub  DSFLOAT[10*4+edi]
        $fsqrt
        $fmul f2_0
        $fstp fTheScale


// Calculate the x, y, x and w of the quaternion through the respective equation
        //x = 0.25f * scale;
        $fld f0_25
        $fmul fTheScale
        $fstp DSFLOAT[ECX+#CQUATERNION.x]

        //y = (pMatrix[4] + pMatrix[1] ) / scale;
        $fld  DSFLOAT[4*4+EDI]
        $fadd DSFLOAT[1*4+EDI]
        $fdiv fTheScale
        $fstp DSFLOAT[ECX+#CQUATERNION.y]

        //z = (pMatrix[2] + pMatrix[8] ) / scale;
        $fld  DSFLOAT[2*4+EDI]
        $fadd DSFLOAT[8*4+EDI]
        $fdiv fTheScale
        $fstp DSFLOAT[ECX+#CQUATERNION.z] 
        //w = (pMatrix[9] - pMatrix[6] ) / scale;	 
        $fld  DSFLOAT[9*4+EDI]
        $fsub DSFLOAT[6*4+EDI]
        $fdiv fTheScale
        $fstp DSFLOAT[ECX+#CQUATERNION.w]
        zaplatka1();
        $jmp PastThisShit



        }
        // Else if the second element of the diagonal is the greatest value
        //else if ( pMatrix[5] > pMatrix[10] ) 

        else IF(DSFLOAT[5*4+EDI]>DSFLOAT[10*4+EDI])
        {
// Find the scale according to the second element, and double that value
//scale  = (float)sqrt( 1.0f + pMatrix[5] - pMatrix[0] - pMatrix[10] ) * 2.0f;
        $fld1
        $fadd DSFLOAT[5*4+EDI]
        $fsub DSFLOAT[0*4+EDI]
        $fsub DSFLOAT[10*4+EDI]
        $fsqrt
        $fmul f2_0
        $fstp fTheScale
// Calculate the x, y, x and w of the quaternion through the respective equation
        //x = (pMatrix[4] + pMatrix[1] ) / scale
        $fld  DSFLOAT[4*4+EDI]
        $fadd DSFLOAT[1*4+EDI]
        $fdiv fTheScale
        $fstp DSFLOAT[ECX+#CQUATERNION.x]
        //y = 0.25f * scale;
        $fld f0_25
        $fmul fTheScale
        $fstp DSFLOAT[ECX+#CQUATERNION.y]
        //z = (pMatrix[9] + pMatrix[6] ) / scale;
        $fld  DSFLOAT[9*4+edi]
        $fadd DSFLOAT[6*4+edi]
        $fdiv fTheScale
        $fstp DSFLOAT[ecx+#CQUATERNION.z]
        //w = (pMatrix[2] - pMatrix[8] ) / scale;
        $fld  DSFLOAT[2*4+edi]
        $fsub DSFLOAT[8*4+edi]
        $fdiv fTheScale
        $fstp DSFLOAT[ecx+#CQUATERNION.w]
        zaplatka1();
        GOTO PastThisShit;
        }
        ELSE
        {
        // Else the third element of the diagonal is the greatest value
        //else 
// Find the scale according to the third element, and double that value
//scale  = (float)sqrt( 1.0f + pMatrix[10] - pMatrix[0] - pMatrix[5] ) * 2.0f;
        $fld1
        $fadd DSFLOAT[10*4+edi]
        $fsub DSFLOAT[ 0*4+edi]
        $fsub DSFLOAT[ 5*4+edi]
        $fsqrt
        $fmul f2_0
        $fstp fTheScale
// Calculate the x, y, x and w of the quaternion through the respective equation
        //x = (pMatrix[2] + pMatrix[8] ) / scale;
        $fld  DSFLOAT[2*4+edi]
        $fadd DSFLOAT[8*4+edi]
        $fdiv fTheScale
        $fstp DSFLOAT[ecx+#CQUATERNION.x]

        //y = (pMatrix[9] + pMatrix[6] ) / scale;
        $fld  DSFLOAT[9*4+edi]
        $fadd DSFLOAT[6*4+edi]
        $fdiv fTheScale
        $fstp DSFLOAT[ecx+#CQUATERNION.y]

        //z = 0.25f * scale;
        $fld  f0_25
        $fmul fTheScale
        $fstp DSFLOAT[ecx+#CQUATERNION.z]


        //w = (pMatrix[4] - pMatrix[1] ) / scale;
        $fld  DSFLOAT[4*4+edi]
        $fsub DSFLOAT[1*4+edi]
        $fdiv fTheScale
        $fstp DSFLOAT[ecx+#CQUATERNION.w]
        }


        zaplatka1();
        zaplatka1();



PastThisShit:
}




//** Convert Euler angles to quaternion
// Note: camera must be properly initialized before calling this
// IN:  ESI=ptr to angles  ࠤ  float
// OUT: EBX=ptr to resulting quaternion
:fastcall quat_Angles2Quaternion(ESI, EBX) 
{
float ex, ey, ez;
float cr, cp, cy;
float sr, sp1, sy;
float cpcy, sp1sy;

/*

		double ex = GUN_DEGTORAD(a.Pitch) / 2.0;
		double ey = GUN_DEGTORAD(a.Yaw  ) / 2.0;
		double ez = GUN_DEGTORAD(a.Roll ) / 2.0;

*/

//ࠤ  ࠤ
ex=DSFLOAT[ESI] * PIq / 180.0f;
ey=DSFLOAT[ESI+4] * PIq / 180.0f;
ez=DSFLOAT[ESI+8] * PIq / 180.0f;
ex/=2.0f;
ey/=2.0f;
ez/=2.0f;





			cr = cos(ex);
			cp = cos(ey);
			cy = cos(ez);


			sr = sin(ex);
			sp1 = sin(ey);
			sy = sin(ez);

			cpcy = cp * cy;
			sp1sy = sp1 * sy;



//		W = float(cr * cpcy + sr * sp1sy);
                $FLD cr
                $FMUL cpcy
                $FLD sr
                $FMUL sp1sy
                $FADD
                $FSTP DSFLOAT[EBX+#CQUATERNION.w]



//		X = float(sr * cpcy - cr * sp1sy);
                $FLD sr
                $FMUL cpcy
                $FLD cr
                $FMUL sp1sy
                $FSUB
                $FSTP DSFLOAT[EBX+#CQUATERNION.x]



//		Y = float(cr * sp1 * cy + sr * cp * sy);
                $FLD cr
                $FMUL sp1
                $FMUL cy


                $FLD sr
                $FMUL cp
                $FMUL sy


                $FADD
                $FSTP DSFLOAT[EBX+#CQUATERNION.y]


//		Z = float(cr * cp * sy - sr * sp1 * cy);
                $FLD cr
                $FMUL cp
                $FMUL sy

                $FLD sr
                $FMUL sp1
                $FMUL cy

                $FSUB
                $FSTP DSFLOAT[EBX+#CQUATERNION.z]

//		Normalize();



}

//x,  y, z ࠤ  ୨ LpOutQuat
//quat_Rotate(90.0, 0.0, 0.0, #q);
//⮦ ᠬ   quat_Angles2Quaternion
:void quat_Rotate(float x, float y, float z, DWORD LpOutQuat)
{
	float a_x[3], a_y[3], a_z[3];

         CQUATERNION q_x, q_y, q_z, tmp, tmp2;


	a_x[0] =  1.0f;  a_x[1] =  0.0f;  a_x[2] =  0.0f;; /* x axis */
	a_y[0] =  0.0f;  a_y[1] =  1.0f;  a_y[2] =  0.0f;; /* y axis */
	a_z[0] =  0.0f;  a_z[1] =  0.0f;  a_z[2] =  1.0f;; /* z axis */

/*

	q_x.SetFromAxis(a_x, DEG2RAD(x));
	q_y.SetFromAxis(a_y, DEG2RAD(y));
	q_z.SetFromAxis(a_z, DEG2RAD(z));


*/

                                            
// ୨  ᭮ 㣫   
//#EAX - 㪠⥫   x.y.z
//#EBX - 㪠⥫  稭 ࠤᮢ
//#EDI - 㪠⥫  室 ୨
//quat_CreateFromAxisAngle(EAX, EBX , EDI)
quat_CreateFromAxisAngle(#a_x, #x , #q_x);
quat_CreateFromAxisAngle(#a_y, #y , #q_y);
quat_CreateFromAxisAngle(#a_z, #z , #q_z);

//tmp.Set(q_x.quat);
//㥬 ୨  tmp
quat_copy (#q_x, #tmp);


//	tmp.Multiply(&q_y);
// ୨
//#esi 㪠⥫  ୨ 1
//#edi 㪠⥫  ୨ 2
//#ecx 㪠⥫  室 ୨ 1*2=3
//fastcall quat_Multiply(ESI, EDI, ECX)
quat_Multiply(#tmp, #q_y, #tmp2);

//Set(tmp.quat);
quat_copy (#tmp2, #tmp);

//	Multiply(&q_z);
quat_Multiply(#tmp, #q_z, #tmp2);


//㥬  室 ୨
quat_copy (#tmp2, LpOutQuat);



//	Normalize();
}
